/*************************************************************************
    bbDMUX2 by Brent Beyeler, beyeler@home.com
*************************************************************************/

// ****  REMEMBER TO DO SOME PROGRESS INFO

#include "bits.h"
#include <string.h>

#undef SHOW_RESYNCHS

#define MPEG_PROGRAM_END_CODE    0x000001B9
#define PACK_START_CODE          0x000001BA
#define SYSTEM_HEADER_START_CODE 0x000001BB
#define PACKET_START_CODE_PREFIX 0x000001

#define PROGRAM_ASSOCIATION_TABLE 0x0000
#define CONDITIONAL_ACCESS_TABLE  0x0001
#define NULL_PACKET               0x1FFF

#define TRANSPORT_SYNC_BYTE      0x47
#define PROGRAM_STREAM_MAP       0xBC
#define PRIVATE_STREAM_1         0xBD
#define PADDING_STREAM           0xBE
#define PRIVATE_STREAM_2         0xBF

#define MPEG_AUDIO_0             0xC0
#define MPEG_AUDIO_7             0xC7

#define MPEG_VIDEO_0             0xE0
#define MPEG_VIDEO_F             0xEF

#define ECM_STREAM               0xF0
#define EMM_STREAM               0xF1
#define PROGRAM_STREAM_DIRECTORY 0xFF
#define DSMCC_STREAM             0xF2
#define ITUTRECH222TYPEE_STREAM  0xF8

#define SUBSTREAM_AC3_0          0x80
#define SUBSTREAM_AC3_8          0x87
#define SUBSTREAM_DTS_0          0x88
#define SUBSTREAM_DTS_8          0x8F
#define SUBSTREAM_PCM_0          0xA0
#define SUBSTREAM_PCM_F          0xAF
#define SUBSTREAM_SUBPIC_0       0x20
#define SUBSTREAM_SUBPIC_1F      0x3F

  unsigned long PES_packet_length, PES_header_data_length;
  unsigned long PTS_DTS_flags, ESCR_flag, ES_rate_flag, DSM_trick_mode_flag;
  unsigned long additional_copy_info_flag, PES_CRC_flag, PES_extension_flag;
  unsigned long PES_private_data_flag, pack_header_field_flag;
  unsigned long pack_header_field_length;
  unsigned long program_packet_sequence_counter_flag, PSTD_buffer_flag;
  unsigned long PES_extension_flag_2, PES_extension_field_length;
  unsigned long bytes_used, encrypted;


  bool firsttime = true;
  unsigned long stream_packets[256], stream_bytes[256], pack_packets;
  unsigned long system_packets;
  unsigned long ac3_bytes[8], dts_bytes[8], pcm_bytes[16], subpic_bytes[32];;
  unsigned long substream_packets[256], substream_bytes[256];

  bool streams_found[256];
  bool stream_encrypted[256];
  bool substream_encrypted[256];
  bool substreams_found[256];

  bool mpeg2;

static int verbose_level=2;
static int col;
static char oldLevel3[80]; //, level3[80];



#define BUFFER_SIZE              32768

static unsigned char Out_BUFFER[BUFFER_SIZE];
static int   Out_Buf_IX, iOut_Curr_SS_Id;
static FILE *Out_File_Ptr[16];
static int  iOut_File_NEXT, iOut_File_CURR, iOut_TotBytes;
static int  iOut_File_SS_Id[17]
;
static char szFileName[16][256], szBaseName[256], szArgLFN[256];
int iArg_Hex_Ctr, iArgStr_Ctr;
int iArg_Hex_Id[2];


static bool vob_flag;
// static void transport_stream(char *fname, int P_argc, int PID_to_get);

int substream_to_get, stream_to_get;

unsigned long iMPEG_File_Format;
int iMpeg_Stream_Id, iMpeg_Substream_Id, iMpeg_SS_Id;
int iMpeg_SS_CAT;
int iMpeg_SS_ABBR;
const char K_STREAM_ABBR[10][4]
     = {"UNK", "M1V", "M2V", "MPA", "AC3", "DTS", "PCM", "SUB", "PS1", "PS2"};
#define CAT_UNK 0
#define CAT_M1V 1
#define CAT_M2V 2
#define CAT_MPA 3
#define CAT_AC3 4
#define CAT_DTS 5
#define CAT_PCM 6
#define CAT_SUB 7
#define CAT_PS1 8
#define CAT_PS2 9



//--------------------------------------
void Out_File_CREATE()
{
// OPEN OUTPUT FILE

int iBase, iLen;
char *pNewName, *pDot;

 iOut_File_CURR = iOut_File_NEXT;
 iOut_File_SS_Id[iOut_File_CURR] = iOut_Curr_SS_Id = iMpeg_SS_Id;

 if (iOut_File_NEXT < 16)
 {
 	  if (iArgStr_Ctr > 1)
    {
      	iBase = 1;
  	}
    else
    {
	      iBase = 0;
    }
    pNewName = &szFileName[iOut_File_NEXT][0];

    // We may need to invent a file name

	  if (stream_to_get < 0 && iOut_File_NEXT > iBase)
	  {
      	strcpy(pNewName, szFileName[iBase]);
      	pDot = strrchr(pNewName, '.') ;

         // Append substream-id to base name if required
         if (iMpeg_Stream_Id != 0xE0 && iMpeg_Stream_Id != 0xC0)
         {
            iLen = sprintf(pDot, "-%x-%x.", iMpeg_Stream_Id,
                                            iMpeg_Substream_Id);
            pDot = pDot + iLen;
         }
         strcpy(pDot, K_STREAM_ABBR[iMpeg_SS_CAT]);
    }

    Out_File_Ptr[iOut_File_CURR] = fopen(pNewName, "wb");

  	if (! Out_File_Ptr[iOut_File_CURR])
    {
        printf("*** Unable to open %s for output\n        ", 
               *pNewName);
        exit (1);
    }
    else
  	{
		  if (iMPEG_File_Format == 1)
   	  {
        	if ((vob_flag) && (iMpeg_Stream_Id == PRIVATE_STREAM_1)
  			   && (iMpeg_Substream_Id > -1))
               printf("Saving stream 0x%02X, substream 0x%02X into file %s...\n",
        		           iMpeg_Stream_Id, iMpeg_Substream_Id, *pNewName);
          else
       		   printf("Saving stream 0x%02X into file %s...\n",
              		    iMpeg_Stream_Id, *pNewName);
      }
      else
      			printf("Saving PID stream 0x%04X into file %s...\n",
              			iMpeg_Stream_Id, *pNewName);
    }

    iOut_File_NEXT++;
 }
}



//------------------------------------
void Out_File_WRITE()
{
  unsigned uRC, uLen;

  uLen = Out_Buf_IX + 1;
  uRC = fwrite(Out_BUFFER, sizeof(unsigned char), uLen,
                Out_File_Ptr[iOut_File_CURR]);

  if (uRC != uLen)
  {
    printf("*** Error writing to output file %s.",
           szFileName[iOut_File_CURR]);
    exit (1);
  }

  iOut_TotBytes = iOut_TotBytes + uRC;

  Out_Buf_IX = -1;
}




//--------------------------------------
void Out_File_SWAP()
{
  int iTmp;

  if (Out_Buf_IX >= 0)
      Out_File_WRITE();

 // May need a different output file if the sub/stream changes

  if (iMpeg_SS_Id != iOut_Curr_SS_Id)
  {
	  iTmp = 1;

 	  while (iOut_File_SS_Id[iTmp] != iMpeg_SS_Id)
    {
   	  // NEW Stream ?
 		  if (iTmp == iOut_File_NEXT)
      {
   		  Out_File_CREATE();
      }
   	  else
	   	  iTmp++;
    }

    iOut_Curr_SS_Id = iMpeg_SS_Id;
  }

}



//-----------------
void Out_File_CLOSE()
{
  if (Out_Buf_IX >= 0)
  		Out_File_WRITE();

  for (iOut_File_CURR = 1;
       iOut_File_CURR < iOut_File_NEXT;
       iOut_File_CURR++)
  {
     if (Out_File_Ptr[iOut_File_CURR])
	  {
  		  fclose(Out_File_Ptr[iOut_File_CURR]);
	  }

  }
}


void Announce_Stream()
{
   switch (iMpeg_Stream_Id)
   {
        case PROGRAM_STREAM_MAP:
             printf("Found stream id 0x%02X  = Program Stream Map\n", iMpeg_Stream_Id);
             break;

        case PRIVATE_STREAM_1:
                if (vob_flag)
                {
                   iMpeg_SS_ABBR = (int)(K_STREAM_ABBR[iMpeg_SS_CAT]);
                   printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X, %s stream\n",
                          iMpeg_Stream_Id,  iMpeg_Substream_Id, iMpeg_SS_ABBR);
                /*
                  if (iMpeg_SS_CAT == CAT_AC3)
                     printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X, AC3 Audio stream %u\n", iMpeg_Stream_Id,  iMpeg_Substream_Id, iMpeg_Substream_Id - SUBSTREAM_AC3_0);
                  else
                  if ((iMpeg_Substream_Id >= SUBSTREAM_DTS_0) && (iMpeg_Substream_Id <= SUBSTREAM_DTS_8))
                     printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X, DTS Audio stream %u\n", iMpeg_Stream_Id, iMpeg_Substream_Id, iMpeg_Substream_Id - SUBSTREAM_DTS_0);
                  else
                  if ((iMpeg_Substream_Id >= SUBSTREAM_PCM_0) && (iMpeg_Substream_Id <= SUBSTREAM_PCM_F))
                     printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X, PCM Audio stream %u\n", iMpeg_Stream_Id, iMpeg_Substream_Id, iMpeg_Substream_Id - SUBSTREAM_PCM_0);
                  else
                  if ((iMpeg_Substream_Id >= SUBSTREAM_SUBPIC_0) && (iMpeg_Substream_Id <= SUBSTREAM_SUBPIC_1F))
                     printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X, Subpicture stream %u\n", iMpeg_Stream_Id, iMpeg_Substream_Id, iMpeg_Substream_Id - SUBSTREAM_SUBPIC_0);
                  else
                     printf("Found stream id 0x%02X  = Private Stream 1, substream 0x%02X\n", iMpeg_Stream_Id, iMpeg_Substream_Id);
                */
                  substreams_found[iMpeg_Substream_Id] = true;
                }
                else
                  printf("Found stream id 0x%02X  = Private Stream 1\n", iMpeg_Stream_Id);
                break;

        case PRIVATE_STREAM_2:
             printf("Found stream id 0x%02X  = Private Stream 2\n", iMpeg_Stream_Id);
             break;

        case ECM_STREAM:
             printf("Found stream id 0x%02X  = ECM Stream\n", iMpeg_Stream_Id);
             break;

        case EMM_STREAM:
             printf("Found stream id 0x%02X  = EMM Stream\n", iMpeg_Stream_Id);
             break;

        case PROGRAM_STREAM_DIRECTORY:
             printf("Found stream id 0x%02X  = Program Stream Directory\n", iMpeg_Stream_Id);
             break;
              
        case DSMCC_STREAM:
             printf("Found stream id 0x%02X  = DSMCC Stream\n", iMpeg_Stream_Id);
             break;

        case ITUTRECH222TYPEE_STREAM:
             printf("Found stream id 0x%02X  = ITU-T Rec. H.222.1 type E\n", iMpeg_Stream_Id);
             break;
              
        case PADDING_STREAM:
             printf("Found stream id 0x%02X  = Padding Stream\n", iMpeg_Stream_Id);
             break;
              
        default:
            if ((iMpeg_Stream_Id >= 0xE0) && (iMpeg_Stream_Id <= 0xEF))
                 printf("Found stream id 0x%02X  = Video Stream %d\n",
                         iMpeg_Stream_Id, iMpeg_Stream_Id - 0xE0);
            else
            if ((iMpeg_Stream_Id >= 0xC0) && (iMpeg_Stream_Id <= 0xDF))
                 printf("Found stream id 0x%02X  = MPEG Audio Stream %d\n",
                         iMpeg_Stream_Id, iMpeg_Stream_Id - 0xC0);
            else
                 printf("Found stream id 0x%02X  = other stream\n",
                         iMpeg_Stream_Id);
   } //end-switch

   streams_found[iMpeg_Stream_Id] = true;

}



//--------------------------------------------------------------
void Mpeg_Private_Split()
{
  unsigned iOffset, kk, uLen;

  if (iMpeg_Substream_Id == substream_to_get)
  {
      if (iMpeg_SS_CAT == CAT_AC3)
      {
          getbits(24);  // discard the 3 AC3 info bytes
          iOffset = 4;
      }

      else
      if (iMpeg_SS_CAT == CAT_DTS)
      {
          getbits(24);  // discard the 3 DTS info bytes
          iOffset = 4;
      }

      else
      if (iMpeg_SS_CAT == CAT_PCM)
      {
          getbits(24);  // discard the 6 PCM info bytes
          getbits(24);
          iOffset = 7;
      }

      else
      if (iMpeg_SS_CAT == CAT_SUB)
          iOffset = 1;
      else
      {
    	   if (iMpeg_SS_Id != iOut_Curr_SS_Id)
	       {
       			Out_File_SWAP();
         }

         Out_BUFFER[++Out_Buf_IX] = (unsigned char)iMpeg_Substream_Id;
         iOffset = 1;
      }

      if (iMpeg_SS_Id != iOut_Curr_SS_Id)
			{
   	   		Out_File_SWAP();
      }

      uLen =  PES_packet_length - PES_header_data_length - 3 - iOffset;
      for (kk = 0;  kk < uLen ; kk++)
      {
           Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
           if (Out_Buf_IX == BUFFER_SIZE - 1)
               Out_File_WRITE();
       }
  } // end substream match

  else
  {    // SKIP
       uLen = PES_packet_length - PES_header_data_length - 4;
       for (iOffset = 0; iOffset <uLen; iOffset++)
            getbits(8);
  }
}

//--------------------------------------------------------------

void  Mpeg_PARSE()
{
  unsigned long i, j, uLen;


  do      // START OF MAIN LOOP
  {
    i = getbits(32);
//nextpass:
    switch (i)
    {
      case PACK_START_CODE:
        pack_packets++;
        if (firsttime)
        {
          mpeg2 = look_ahead(2) == 1; // check if MPEG-1 or MPEG-2
          if (mpeg2)
            printf("\nFile %s\n     is an MPEG-2 Program Stream\n\n",
                     szFileName[0]);
          else
            printf("\nFile %s\n     is an MPEG-1 Program Stream\n\n",
                     szFileName[0]);
          firsttime = false;
        }

        if (mpeg2)
        {
          getbits(32);   // MPEG-2 pack header
          getbits(32);
          getbits(13);
          i = getbits(3); // Variable length
          for (j = 0; j < i; j++)
            getbits(8);  // stuffing bytes
        }
        else
        {
          getbits(32);   // MPEG-1 pack header
          getbits(32);   // Fixed length
        }

        break;


      case SYSTEM_HEADER_START_CODE:
        system_packets++;
                     // **** WHAT ABOUT THE LENGTH FIELD ????? <==========
        getbits(32);   // system header
        getbits(32);
        while (look_ahead(1) == 1)
          getbits(24); // P-STD info
        break;


      case MPEG_PROGRAM_END_CODE:
        break;


      default:
        if ((i >> 8) != PACKET_START_CODE_PREFIX)
//        {
          break;
//#ifdef SHOW_RESYNCHS
//          if (P_argc > 3)
//          {
//            printf("\nUnknown bits in stream = 0x%08X at byte %.0f\n", i, bitcount() / 8 - 4);
//            printf("\nAttempting resynch ... ");
//          }
//#endif
//          if (seek_sync(PACKET_START_CODE_PREFIX, 24))
//          {
//            i = 0x00000100 | getbits(8);
//#ifdef SHOW_RESYNCHS
//            if (P_argc > 3)
//              printf("succesfully resynched\n");
//#endif
//            goto nextpass;
//          }
//#ifdef SHOW_RESYNCHS
//          if (P_argc > 3)
//            printf("could not resynch\n");
//          else
//#endif
//            printf("\nUnknown bits in stream = 0x%08X at byte %.0f\n", i, bitcount() / 8 - 4);
//          Out_File_CLOSE();
//          exit(1);
//        }

        iMpeg_Stream_Id = i & 0x000000FF;
        stream_packets[iMpeg_Stream_Id]++;

        iMpeg_Substream_Id = -1;
        iMpeg_SS_CAT = 0;
        iMpeg_SS_Id = iMpeg_Stream_Id;

        // Categorize the Stream

        if ((iMpeg_Stream_Id >= MPEG_VIDEO_0)
         && (iMpeg_Stream_Id <= MPEG_VIDEO_F))
        {
            if (mpeg2)
           	    iMpeg_SS_CAT = CAT_M2V;
            else
           	    iMpeg_SS_CAT = CAT_M1V;
        }
        else
        if ((iMpeg_Stream_Id >= MPEG_AUDIO_0)
         && (iMpeg_Stream_Id <= MPEG_AUDIO_7))
        {
           	 iMpeg_SS_CAT = CAT_MPA;
        }

        PES_packet_length = getbits(16);
        encrypted = 0;

        switch (iMpeg_Stream_Id)
        {
          case PROGRAM_STREAM_MAP:
          case ECM_STREAM:
          case EMM_STREAM:
          case PROGRAM_STREAM_DIRECTORY:
          case DSMCC_STREAM:
          case ITUTRECH222TYPEE_STREAM:
          // case PRIVATE_STREAM_2:          //  <----- WHAT ABOUT OZ HD AC3 ?
          case PADDING_STREAM:
            if (iMpeg_Stream_Id == stream_to_get)
            {
              if (iMpeg_SS_Id != iOut_Curr_SS_Id)
	           {
   	            Out_File_SWAP();
      	     }
              for (j = 0; j < PES_packet_length; j++)
              {
                Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
                if (Out_Buf_IX == BUFFER_SIZE - 1)
                    Out_File_WRITE();
              }
            }

            for (j = 0; j < PES_packet_length; j++)
                getbits(8);

            stream_bytes[iMpeg_Stream_Id] += j;
            break;

          default:
            bytes_used = 0;

            if ( ! mpeg2)   // MPEG1
            {
              /* flush stuffing bytes */
              while (look_ahead(8) == 0xff)
              {
                getbits(8);
                bytes_used++;
              }

              if (look_ahead(2) == 1)
              {
                /* Get STD buffer size */
                getbits(16);
                bytes_used += 2;
              }

              if (look_ahead(4) == 2)
              {
                /* Get presentation time stamp and flag it as present in packet*/
                getbits(32);
                getbits(8);
                bytes_used += 5;
              }

              else
              if (look_ahead(4) == 3)
              {
                  /* Get presentation time stamp and decoding time stamp */
                  getbits(32);
                  getbits(8);
                  getbits(32);
                  getbits(8);
                  bytes_used += 10;
              }

              else
              {
                  if (getbits(8) != 0x0f)
                  {
                    printf("Invalid bits in MPEG-1 file %s.",
                            szFileName[0]);
                    exit (1);
                  }
                  bytes_used++;
              }

              stream_bytes[iMpeg_Stream_Id] += PES_packet_length - bytes_used;

              // OUTPUT  MPEG1 DATA

              if (iMpeg_Stream_Id == stream_to_get
              || (iMpeg_SS_CAT != CAT_UNK && stream_to_get == -1))
              {
                if (iMpeg_SS_Id != iOut_Curr_SS_Id)
	             {
   	              Out_File_SWAP();
      	       }

                uLen = PES_packet_length - bytes_used;
                for (j = 0; j < uLen; j++)
                {
                  Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
                  if (Out_Buf_IX == BUFFER_SIZE - 1)
                      Out_File_WRITE();
                }
              }

              else
              {      // SKIP PACKET
                uLen = PES_packet_length - bytes_used;
                for (j = 0; j < uLen; j++)
                  getbits(8);
              }

            } // END-IF NOT MPEG2


            else        // MPEG2
            {
              getbits(2);
              encrypted = getbits(2);   // PES_scrambling_control
              getbits(4);

              PTS_DTS_flags = getbits(2);

              ESCR_flag = get1bit();
              ES_rate_flag = get1bit();
              DSM_trick_mode_flag = get1bit();
              additional_copy_info_flag = get1bit();
              PES_CRC_flag = get1bit();
              PES_extension_flag = get1bit();
              PES_header_data_length = getbits(8);

              if (PTS_DTS_flags > 1)
              {
                getbits(32);   // PTS stamp
                getbits(8);
                bytes_used += 5;
              }

              if (PTS_DTS_flags > 2)
              {
                getbits(32);   // DTS stamp
                getbits(8);
                bytes_used += 5;
              }

              if (ESCR_flag == 1)
              {
                getbits(32);
                getbits(16);
                bytes_used += 6;
              }

              if (ES_rate_flag == 1)
              {
                getbits(24);
                bytes_used += 3;
              }

              if (DSM_trick_mode_flag == 1)
              {
                getbits(8);
                bytes_used++;
              }

              if (additional_copy_info_flag == 1)
              {
                getbits(8);
                bytes_used++;
              }

              if (PES_CRC_flag == 1)
              {
                getbits(16);
                bytes_used += 2;
              }

              if (PES_extension_flag == 1)
              {
                PES_private_data_flag  = get1bit();
                pack_header_field_flag = get1bit();
                program_packet_sequence_counter_flag = get1bit();
                PSTD_buffer_flag = get1bit();
                getbits(3);
                PES_extension_flag_2 = get1bit();
                bytes_used++;

                if (PES_private_data_flag == 1)
                {
                  for (j = 0; j < 128; j++)
                    getbits(8);
                  bytes_used += 128;
                }

                if (pack_header_field_flag == 1)
                {
                  //printf("    pack header field flag value not allowed in program streams\n");
                  // exit(1);

                  pack_header_field_length = getbits(8);
                  //pack_header();
                  for (j = 0; j < pack_header_field_length; j++)
                      getbits(8);
                  bytes_used += 1 + pack_header_field_length;
                }

                if (program_packet_sequence_counter_flag == 1)
                {
                  getbits(16);   // <------- SUS
                  bytes_used += 2;
                }

                if (PSTD_buffer_flag == 1)
                {
                  getbits(16);
                  bytes_used += 2;
                }

                if (PES_extension_flag_2 == 1)
                {
                  get1bit();
                  PES_extension_field_length = getbits(7);
                  bytes_used++;
                  for (j = 0; j < PES_extension_field_length; j++)
                  {
                    getbits(8);
                    bytes_used++;
                  }
                }

              } // END PES-Extension

              uLen = PES_header_data_length - bytes_used;
              for (j = 0; j < uLen; j++)
                getbits(8);

              iMpeg_Substream_Id = getbits(8);
              iMpeg_SS_Id = (iMpeg_Substream_Id <<8) + iMpeg_Stream_Id ;

		          // INCREMENT STATS

              stream_bytes[iMpeg_Stream_Id] += PES_packet_length - PES_header_data_length - 3;

			        // Categorize the substream

              if (iMpeg_SS_CAT == CAT_UNK)
              {
	               if ((iMpeg_Substream_Id >= SUBSTREAM_AC3_0)
   	             && (iMpeg_Substream_Id <= SUBSTREAM_AC3_8))
                 {
         	     	 iMpeg_SS_CAT = CAT_AC3;
                 }

	              else
   	            if ((iMpeg_Substream_Id >= SUBSTREAM_DTS_0)
      	         &&  (iMpeg_Substream_Id <= SUBSTREAM_DTS_8))
         	      {
            	  	iMpeg_SS_CAT = CAT_DTS;
	               }

   	            else
      	        if ((iMpeg_Substream_Id >= SUBSTREAM_PCM_0)
         	       && (iMpeg_Substream_Id <= SUBSTREAM_PCM_F))
                {
	              	iMpeg_SS_CAT = CAT_PCM;
                }

                else
         	      if ((iMpeg_Substream_Id >= SUBSTREAM_SUBPIC_0)
            	   &&  (iMpeg_Substream_Id <= SUBSTREAM_SUBPIC_1F))
                {
		              	iMpeg_SS_CAT = CAT_SUB;
                }

              }   // END Subtream CATegorization


              // Increment substream type byte totals
              if ((iMpeg_Stream_Id == PRIVATE_STREAM_1) && (vob_flag))
              {
                substream_packets[iMpeg_Substream_Id]++;
                j = PES_packet_length - PES_header_data_length - 3;
                substream_bytes[iMpeg_Substream_Id] += j;
                if (iMpeg_SS_CAT == CAT_AC3)
                  ac3_bytes[iMpeg_Substream_Id - SUBSTREAM_AC3_0] += j - 4;
                if (iMpeg_SS_CAT == CAT_DTS)
                  dts_bytes[iMpeg_Substream_Id - SUBSTREAM_DTS_0] += j - 4;
                if (iMpeg_SS_CAT == CAT_PCM)
                  pcm_bytes[iMpeg_Substream_Id - SUBSTREAM_PCM_0] += j - 7;
                if (iMpeg_SS_CAT == CAT_SUB)
                  subpic_bytes[iMpeg_Substream_Id - SUBSTREAM_SUBPIC_0] += j - 1;
              }


              if (iMpeg_Stream_Id == stream_to_get
              || (iMpeg_SS_CAT != CAT_UNK && stream_to_get == -1))
              {
				        // SPECIAL PROCESSING FOR PRIVATE STREAMS

                if ((  iMpeg_Stream_Id == PRIVATE_STREAM_2
                    || iMpeg_Stream_Id == PRIVATE_STREAM_1) // && (vob_flag)
                 && (substream_to_get > -2))
                {
                    Mpeg_Private_Split();
                } // END Private Substream splitting

                else
                {  
                   // STREAM REGARDLESS OF SUB-STREAM

                   if (iMpeg_SS_Id != iOut_Curr_SS_Id)
                   {
   	              	Out_File_SWAP();
                   }

                   Out_BUFFER[++Out_Buf_IX] = (unsigned char)iMpeg_Substream_Id;
                   if (Out_Buf_IX == BUFFER_SIZE - 1)
                       Out_File_WRITE();

                   uLen = PES_packet_length - PES_header_data_length - 4;
                   for (j = 0; j < uLen; j++)
                   {
                       Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
                       if (Out_Buf_IX == BUFFER_SIZE - 1)
                           Out_File_WRITE();
                   }

                }   // END NOT PRIVATE SPLIT 

              } // END-TRUE FOR STREAM WANTED

              else
              {  
                //SKIP  SUB-STREAM
                uLen = PES_packet_length - PES_header_data_length - 4;
                for (j = 0; j < uLen; j++)
                  getbits(8);
              } // END Interesting STREAM_ID handling

            } // END MPEG2

            break;

        } // END-switch (iMpeg_Stream_Id)
      



		  // INFO MODE - DISPLAY STREAM INFO WHEN FIRST FOUND

		  if ( stream_to_get < -1)
      {
          // First time through, announce stream found

          if ((!streams_found[iMpeg_Stream_Id])
          || ((vob_flag) && (iMpeg_Stream_Id == PRIVATE_STREAM_1)
                         && (!substreams_found[iMpeg_Substream_Id])))
          {
            Announce_Stream();
          } // END-First Time announcement

          // MORE ANNOUNCEMENTS
          if (encrypted)
          {
            if ((iMpeg_Stream_Id == PRIVATE_STREAM_1) && (vob_flag))
            {
              if (!substream_encrypted[iMpeg_Substream_Id])
              {
                printf("Stream id 0x%02X, substream 0x%02X is encrypted\n", iMpeg_Stream_Id, iMpeg_Substream_Id);
                substream_encrypted[iMpeg_Substream_Id] = true;
              }
            }

            else
            {
              if (!stream_encrypted[iMpeg_Stream_Id])
              {
                printf("Stream id 0x%02X is encrypted\n", iMpeg_Stream_Id);
                stream_encrypted[iMpeg_Stream_Id] = true;
              }
            }

          } // END encrypted test 

      } // END-IF INFO MODE

    }  // END-SWITCH (i) Mpeg_Packet_Code

  } while ( (i != MPEG_PROGRAM_END_CODE) && (!end_bs() ) );  
  // END MAIN DO LOOP


  // END OF DATA
}




//---------------------------------------------------------------



void Y100_STATS()
{
  unsigned i, j;

  printf("\nSummary:\n");
  printf("\nMPEG Packs = %d\n", pack_packets);
  if (system_packets)
    printf("System headers = %d\n", system_packets);
  
  for (i = 0; i < 256; i++)
  {
    if (stream_packets[i])
    {
      switch (i)
      {
        case PROGRAM_STREAM_MAP:
          printf("Program Stream Map  - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case PRIVATE_STREAM_1:
          printf("Private Stream  #1 - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          if (vob_flag)
          {
            for (j = 0; j < 256; j++)
            {
              if (substream_packets[j])
              {
                if ((j >= SUBSTREAM_AC3_0) && (j <= SUBSTREAM_AC3_8))
                  printf("    AC3 Audio stream #%u - %u packets, %u bytes\n",
                   j - SUBSTREAM_AC3_0, substream_packets[j], ac3_bytes[j - SUBSTREAM_AC3_0]);
                else
                if ((j >= SUBSTREAM_DTS_0) && (j <= SUBSTREAM_DTS_8))
                   printf("    DTS Audio stream  #%u - %u packets, %u bytes\n",
                    j - SUBSTREAM_DTS_0, substream_packets[j], dts_bytes[j - SUBSTREAM_DTS_0]);
                else
                if ((j >= SUBSTREAM_PCM_0) && (j <= SUBSTREAM_PCM_F))
                   printf("    PCM Audio stream #%u packets = %u, total bytes = %u\n",
                    j - SUBSTREAM_PCM_0, substream_packets[j], pcm_bytes[j - SUBSTREAM_PCM_0]);
                else
                if ((j >= SUBSTREAM_SUBPIC_0) && (j <= SUBSTREAM_SUBPIC_1F))
                   printf("    Subpicture stream  #%u - %u packets, %u bytes\n",
                    j - SUBSTREAM_SUBPIC_0, substream_packets[j], subpic_bytes[j - SUBSTREAM_SUBPIC_0]);
                else
                   printf("    Substream 0x%02X - %u packets, %u bytes\n",
                    j, substream_packets[j], substream_bytes[j]);
              } // END-IF
              
            } // END-FOR

          } // END-IF vob
          break;

        case PRIVATE_STREAM_2:
          printf("Private Stream #2   - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case ECM_STREAM:
          printf("ECM Stream         - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case EMM_STREAM:
          printf("EMM Stream packets - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case PROGRAM_STREAM_DIRECTORY:
          printf("Program Stream Directory - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case DSMCC_STREAM:
          printf("DSMCC Stream packets - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case ITUTRECH222TYPEE_STREAM:
          printf("ITU-T Rec. H.222.1 type E - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        case PADDING_STREAM:
          printf("Padding Stream - %u packets, %u bytes\n", stream_packets[i], stream_bytes[i]);
          break;
        default:
          if ((i >= 0xE0) && (i <= 0xEF))
             printf("Video stream #%d - %u packets, %u bytes\n", i - 0xE0, stream_packets[i], stream_bytes[i]);
          else
          if ((i >= 0xC0) && (i <= 0xDF))
             printf("MPEG Audio stream #%d - %u packets, %u bytes\n", i - 0xC0, stream_packets[i], stream_bytes[i]);
          else
             printf("Other stream 0x%02X - %u packets, %u bytes\n", i, stream_packets[i], stream_bytes[i]);
      } // END-SWITCH

    } // END-IF stream_packets

  } // END-FOR
}




//--------------------------------------
int main(int P_argc, char* P_argv[])
{
  unsigned long i;


  char tmpStr[256];
  //char *ext;

  int iRC, iLen;

  iOut_File_NEXT = 1; iOut_File_CURR = -1;
  iOut_TotBytes = 0;

  Out_Buf_IX = -1;
  Out_File_Ptr[iOut_File_CURR] = NULL;
  iOut_Curr_SS_Id = -1234567;

  stream_to_get = -123456;
  substream_to_get = -123456;

  for (i = 0; i < 256; i++)
  {
    streams_found[i] = false;
    stream_packets[i] = 0;
    stream_bytes[i] = 0;
    substreams_found[i] = false;
    stream_encrypted[i] = false;
    substream_encrypted[i] = false;
    substream_packets[i] = 0;
    substream_bytes[i] = 0;
  }

  for (i = 0; i < 8; i++)
  {
    ac3_bytes[i] = 0;
    dts_bytes[i] = 0;
  }

  for (i = 0; i < 16; i++)
    pcm_bytes[i] = 0;
  for (i = 0; i < 32; i++)
    subpic_bytes[i] = 0;

  pack_packets = 0;
  system_packets = 0;

  mpeg2 = false;

  printf("bbDMUX2 - version 2   Mods by RocketJet\n");
  printf("        - based on 1.9 by Brent Beyeler (beyeler@home.com)\n");
  printf("        - speed increases by Apachez and Christian Vogelgsang\n\n");
  if (P_argc < 2)
  {
    printf("bbDMUX2 de-multiplexs an MPEG Transport or Program Stream \n\n");
    printf("Usage: bbDMUX2  MPEG filename  <stream id/PID>  <output name>  <substream id>\n\n");
    printf("Program Stream examples:\n");
    printf("    List stream-ids and substreams\n");
    printf("      bbDMUX2  testfile.mpg\n\n");
    printf("    Demux ALL Video and Audio streams and substreams\n");
    printf("      bbDMUX2  testfile.mpg ALL ALL\n\n");
    printf("    Video stream only (stream 0xe0)\n");
    printf("      bbDMUX2  testfile.m2p   0xE0 \n\n");
    printf("    Video stream - overriding default output name\n");
    printf("      bbDMUX2  testfile.m2p   0xe0  FRED.M2V\n\n");
    printf("    Mpeg Audio only   (stream 0xc0)\n");
    printf("      bbDMUX2  testfile.mpg   0xc0\n\n");
    printf("    AC3 audio stream (stream 0xbd substream 0x80)\n");
    printf("      bbDMUX2  testfile.vob  0xbd  0x80\n\n");
    printf("Transport Stream example:\n");
    printf("    Video stream      (PID = 0x001b)\n");
    printf("      bbDMUX2  testfile.vob  0x001B\n");
	 exit (1);
  }

// Analyse and store parameters

  int iArg_Ix, iArg_Len;
  int iParContext; //, iTmp1 ;
  char szArg[256], *pArg_Dot; //, cTmp1;

  iParContext = iArg_Hex_Ctr = iArgStr_Ctr = 0;

  for (iArg_Ix = 1 ; iArg_Ix < P_argc ; iArg_Ix++)
  {
		strcpy(szArg, P_argv[iArg_Ix]);
      iArg_Len = strlen(szArg);
		pArg_Dot = strrchr(szArg, '.') ;

		  // Determine parameter type

      // continuing a quoted file name with imbedded spaces ?

      if (iParContext == 1)
      {
      	strcat(szArgLFN, " ");
      	strcat(szArgLFN, szArg);
         if (strchr(szArg, '"') != NULL)
         {
            strcpy(szFileName[iArgStr_Ctr], szArgLFN);
            if (iArgStr_Ctr < 1)
	              iArgStr_Ctr++;
            else
            {
              printf("*** More than 2 file names found ***\n%s\n",szArg);
	            exit (1);
            }
            
            iParContext = 0;
         }
      }

      else
      // Quoted File Name ?
      if (szArg[0] == '"')
      {
         strcpy(szArgLFN, szArg);
         // if no terminating quote, then allow for imbedded spaces in file name
         if (strrchr(szArg, '"') != &szArg[0])
             iParContext = 1;
         else
         {
            strcpy(szFileName[iArgStr_Ctr], szArgLFN);
            iArgStr_Ctr++;
         }
      }
      else
      {
	       if (!stricmp(szArg, "ALL"))
         {
           	iArg_Hex_Id[iArg_Hex_Ctr] = -1;
            iArg_Hex_Ctr++;
         }

         else
         if (pArg_Dot != NULL)
         {
           strcpy(szFileName[iArgStr_Ctr], szArgLFN);
           iArgStr_Ctr++;
         }

         else
         {
      	    iRC = 0;
		  	    iLen = strlen(szArg);
            if (iLen ==2)                  iRC = sscanf(szArg,   "%x", &i);
		        else
		        if (memicmp(szArg,"0x",2) ==0) iRC = sscanf(szArg, "0x%x", &i);

			      if (iRC == 1)
            {
         	      iArg_Hex_Id[iArg_Hex_Ctr] = i;
                iArg_Hex_Ctr++;
            }
            else
            {
                printf("*** Hex parms need '0x' prefix; Filenames need a dot '.'\n   Not sure what this is: %s\n",
                         szArg);
	              exit (1);
            }
         }
         
         //iArg_Ix++;
      } // END-ELSE WORD TYPE

  }  // END-FOR each parm word

  init_getbits(szFileName[0]);

  strcpy(tmpStr, szFileName[0]);
  strlwr(tmpStr);
  vob_flag = (strstr(tmpStr, ".vob") != NULL);

  iMPEG_File_Format = 0;
  while (!iMPEG_File_Format)
  {
     if (look_ahead(32) == PACK_START_CODE)
         iMPEG_File_Format = 1;
     else
     if (look_ahead(8) == TRANSPORT_SYNC_BYTE)
         iMPEG_File_Format = 2;
     else
         getbits(8);
  }

  if (!iMPEG_File_Format)
  {
    printf("\n*** Unknown file type.\n");
    exit(1);
  }




  if (iArg_Hex_Ctr > 0)
  {
    i = iArg_Hex_Id[0];
    if (iMPEG_File_Format == 1)
    {
      if ( i > 0xFF)
      {
        printf("*** Stream ID must be in the range 00..0xFF\n");
        exit (1);
      }
    }
    else
    {
      if (i > 0x1FFF)
      {
        printf("*** PID must be in the range 00..0x1FFF\n");
        exit (1);
      }
    }
    stream_to_get = i;

 /*
    char cTmp1;
    char *pDot;
    if (P_argc > 3)
    {
      Parm_Anl(3);

    }
    else
    {
      printf("*** An output filename must be specified\n");
      exit(1);
    }
 */

    if (iArg_Hex_Ctr > 1)
    {
	   i = iArg_Hex_Id[1];
      if (i > 0xFF)
      {
        printf("Substream ID must be in the range 0..0xFF\n");
        exit (1);
      }
      substream_to_get = i;
      vob_flag = true;
    }
  }

  if (substream_to_get < 0)
  {
    if (iMPEG_File_Format == 1)
      printf("Scanning for stream id's, press control-c to quit ...\n");
    else
      printf("Scanning for PID's, press control-c to quit ...\n");
  }



  if (iMPEG_File_Format == 2)
  {
    printf("****  TS IS NOT SUPPORTED IN THIS VERSION **** \n");
    // transport_stream(szFileName[0], P_argc, stream_to_get);
    exit(12);
  }




// PARSE INPUT STREAM
  Mpeg_PARSE();

  // PRINT SOME STATS
  Y100_STATS();
  // CLEAN-UP FILES

  finish_getbits();
  Out_File_CLOSE();

  // Status code to indicate if we output anything
  if(iOut_TotBytes || stream_to_get < -1)
  	 return (0);
  else
    return (8);


}



//------------------------------------------------------



void zprintf(int level, char *tmpStr, int value)
{
  if (verbose_level > 2) // Packet type reports wanted
  {
    if (level > 2) // Packet type report line
    {
      if ((col + strlen(tmpStr) > 76)
      || (tmpStr[2] != oldLevel3[2]))
      {
        col = 0;
        printf("\n");
      }
      printf(tmpStr);
      col += strlen(tmpStr);
      strcpy(oldLevel3, tmpStr);
    }
  }
  else
    if (level <= verbose_level)
      printf(tmpStr, value);

  //  fflush(stdout);
}






 /*
struct stream_entry {
  unsigned long iMpeg_Stream_Id;
  unsigned long iMpeg_Substream_Id;
  unsigned long stream_packets;
  unsigned long stream_bytes;
  int stream_encrypted;
  int stream_found;
  int pcm_bytes;
  int subpic_bytes;
  int ac3_bytes;
  int dts_bytes;
};


void transport_stream(char *fname, int P_argc, int PID_to_get)
{
  unsigned long i, j, k, PES_packet_length, PES_header_data_length;
  unsigned long adaptation_bytes;
  int payload_unit_start_indicator, PID;
  bool firsttime = true;
  unsigned long transport_packets, packet_data_bytes;
  stream_entry *streams[8192];

  for (i = 0; i < 8192; i++)
    streams[i] = NULL;
  transport_packets = 0;
  Out_Buf_IX = -1;

  do
  {
    i = getbits(8);
//nextpass:
    if (i == TRANSPORT_SYNC_BYTE)
    {
      transport_packets++;
      if (firsttime)
      {
        printf("\nFile %s is an MPEG-2 Transport Stream\n\n", fname);
        firsttime = false;
      }
      j = getbits(3);
      payload_unit_start_indicator = (j & 0x2) >> 1;

      PID = getbits(13);
      if (streams[PID] == NULL)
      {
        streams[PID] = (stream_entry*)malloc(sizeof(stream_entry));
        if (streams[PID] == NULL)
        {
          printf("Unable to allocate memory for stream entry.\n");
          exit(1);
        }
        streams[PID]->iMpeg_Stream_Id = 0;
        streams[PID]->iMpeg_Substream_Id = 0;
        streams[PID]->stream_packets = 0;
        streams[PID]->stream_bytes = 0;
        streams[PID]->stream_encrypted = 0;
        streams[PID]->stream_found = 0;
        streams[PID]->pcm_bytes = 0;
        streams[PID]->subpic_bytes = 0;
        streams[PID]->ac3_bytes = 0;
        streams[PID]->dts_bytes = 0;
      }
      streams[PID]->stream_packets++;
      getbits(2);
      i = getbits(2);
      getbits(4);
      if (i > 1)
      {
        j = getbits(8);
        for (k = 0; k < j; k++)
          getbits(8);
        adaptation_bytes = j + 1;
      }
      else
        adaptation_bytes = 0;
      if ((i == 1) || (i == 3))
      {
        packet_data_bytes = 184 - adaptation_bytes;
        if (packet_data_bytes > 0)
        {
          if ((look_ahead(24) == 0x000001) && payload_unit_start_indicator && (PID > 0x0F))
          {
            i = getbits(32);
            packet_data_bytes -= 4;
            if ((i >> 8) != PACKET_START_CODE_PREFIX)
            {
              printf("Packet start code not found.\n");
              exit(1);
            }
            streams[PID]->iMpeg_Stream_Id = i & 0x000000FF;
            PES_packet_length = getbits(16);
            packet_data_bytes -= 2;
            switch (streams[PID]->iMpeg_Stream_Id)
            {
              case PROGRAM_STREAM_MAP:
              case ECM_STREAM:
              case EMM_STREAM:
              case PROGRAM_STREAM_DIRECTORY:
              case DSMCC_STREAM:
              case ITUTRECH222TYPEE_STREAM:
              case PRIVATE_STREAM_2:
              case PADDING_STREAM:
                break;

              default:
                getbits(2);
                streams[PID]->stream_encrypted = getbits(2);   // PES_scrambling_control
                getbits(12);
                PES_header_data_length = getbits(8);
                packet_data_bytes -= (3 + PES_header_data_length);
                for (j = 0; j < PES_header_data_length; j++)
                  getbits(8);

                streams[PID]->iMpeg_Substream_Id = getbits(8);
                if ((streams[PID]->iMpeg_Stream_Id == PRIVATE_STREAM_1) && (vob_flag))
                {
                  j = PES_packet_length - PES_header_data_length - 3;
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_AC3_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_AC3_8))
                    streams[PID]->ac3_bytes += j - 4;
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_DTS_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_DTS_8))
                    streams[PID]->dts_bytes += j - 4;
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_PCM_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_PCM_F))
                    streams[PID]->pcm_bytes += j - 7;
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_SUBPIC_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_SUBPIC_1F))
                    streams[PID]->subpic_bytes += j - 1;
                }

                if ((streams[PID]->iMpeg_Stream_Id == PRIVATE_STREAM_1) && (vob_flag))
                {
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_AC3_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_AC3_8))
                  {
                    getbits(24);  // discard the 3 AC3 info bytes
                    j = 4;
                  }
                  else
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_DTS_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_DTS_8))
                  {
                      getbits(24);  // discard the 3 DTS info bytes
                      j = 4;
                  }
                  else
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_PCM_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_PCM_F))
                  {
                      getbits(24);  // discard the 6 PCM info bytes
                      getbits(24);
                      j = 7;
                  }
                  else
                  if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_SUBPIC_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_SUBPIC_1F))
                      j = 1;
                  else
                  {
                  	if (PID == PID_to_get)
                  	{
                        if (iMpeg_SS_Id != iOut_Curr_SS_Id)
				            {
   	              			Out_File_SWAP();
      	      			}

                        Out_BUFFER[++Out_Buf_IX] = (unsigned char)streams[PID]->iMpeg_Substream_Id;
                        if (Out_Buf_IX == BUFFER_SIZE - 1)
                            Out_File_WRITE();
                     }
                     j = 1;
                     streams[PID]->stream_bytes++;
                  }
                  packet_data_bytes -= j;
                }
                else
                {
                  if (PID == PID_to_get)
                  {
                     if (iMpeg_SS_Id != iOut_Curr_SS_Id)
				         {
   	            		Out_File_SWAP();
      	      		}

                    Out_BUFFER[++Out_Buf_IX] = (unsigned char)streams[PID]->iMpeg_Substream_Id;
                    if (Out_Buf_IX == BUFFER_SIZE - 1)
                      Out_File_WRITE();
                  }
                  streams[PID]->stream_bytes++;
                  packet_data_bytes--;
                }
                break;
            }
            if (packet_data_bytes > 0)
            {
              if (PID == PID_to_get)
              {
                if (iMpeg_SS_Id != iOut_Curr_SS_Id)
				    {
   	          	Out_File_SWAP();
      	       }

                for (j = 0; j < packet_data_bytes; j++)
                {
                  Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
                  if (Out_Buf_IX == BUFFER_SIZE - 1)
                    Out_File_WRITE();
                }
              }
              else
              {
                for (j = 0; j < packet_data_bytes; j++)
                  getbits(8);
              }
              streams[PID]->stream_bytes += j;
            }
          }
          else
          {
            if (PID == PID_to_get)
            {
              if (iMpeg_SS_Id != iOut_Curr_SS_Id)
				  {
   	         	Out_File_SWAP();
      	     }

              for (j = 0; j < packet_data_bytes; j++)
              {
                Out_BUFFER[++Out_Buf_IX] = (unsigned char)getbits(8);
                if (Out_Buf_IX == BUFFER_SIZE - 1)
                    Out_File_WRITE();
              }
            }
            else
            {
              for (j = 0; j < packet_data_bytes; j++)
                getbits(8);
            }
            streams[PID]->stream_bytes += j;
          }
        }

        if ((stream_to_get < -1) && (!streams[PID]->stream_found))
        {
          switch (streams[PID]->iMpeg_Stream_Id)
          {
            case PROGRAM_STREAM_MAP:
              printf("Found PID 0x%04X, stream id 0x%02X = Program Stream Map\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case PRIVATE_STREAM_1:
              if (vob_flag)
              {
                if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_AC3_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_AC3_8))
                  printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1, substream 0x%02X, AC3 Audio stream %u\n", PID, streams[PID]->iMpeg_Stream_Id,  streams[PID]->iMpeg_Substream_Id, streams[PID]->iMpeg_Substream_Id - SUBSTREAM_AC3_0);
                else
                if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_DTS_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_DTS_8))
                    printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1, substream 0x%02X, DTS Audio stream %u\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Substream_Id, streams[PID]->iMpeg_Substream_Id - SUBSTREAM_DTS_0);
                else
                if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_PCM_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_PCM_F))
                      printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1, substream 0x%02X, PCM Audio stream %u\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Substream_Id, streams[PID]->iMpeg_Substream_Id - SUBSTREAM_PCM_0);
                else
                if ((streams[PID]->iMpeg_Substream_Id >= SUBSTREAM_SUBPIC_0) && (streams[PID]->iMpeg_Substream_Id <= SUBSTREAM_SUBPIC_1F))
                        printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1, substream 0x%02X, Subpicture stream %u\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Substream_Id, streams[PID]->iMpeg_Substream_Id - SUBSTREAM_SUBPIC_0);
                else
                        printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1, substream 0x%02X\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Substream_Id);
              }
              else
                printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 1\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case PRIVATE_STREAM_2:
              printf("Found PID 0x%04X, stream id 0x%02X = Private Stream 2\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case ECM_STREAM:
              printf("Found PID 0x%04X, stream id 0x%02X = ECM Stream\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case EMM_STREAM:
              printf("Found PID 0x%04X, stream id 0x%02X = EMM Stream\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case PROGRAM_STREAM_DIRECTORY:
              printf("Found PID 0x%04X, stream id 0x%02X = Program Stream Directory\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case DSMCC_STREAM:
              printf("Found PID 0x%04X, stream id 0x%02X = DSMCC Stream\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case ITUTRECH222TYPEE_STREAM:
              printf("Found PID 0x%04X, stream id 0x%02X = ITU-T Rec. H.222.1 type E\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            case PADDING_STREAM:
              printf("Found PID 0x%04X, stream id 0x%02X = Padding Stream\n", PID, streams[PID]->iMpeg_Stream_Id);
              break;
            default:
              if ((streams[PID]->iMpeg_Stream_Id >= 0xE0) && (streams[PID]->iMpeg_Stream_Id <= 0xEF))
                printf("Found PID 0x%04X, stream id 0x%02X = Video Stream %d\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Stream_Id - 0xE0);
              else
                if ((streams[PID]->iMpeg_Stream_Id >= 0xC0) && (streams[PID]->iMpeg_Stream_Id <= 0xDF))
                  printf("Found PID 0x%04X, stream id 0x%02X = MPEG Audio Stream %d\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Stream_Id - 0xC0);
                else
                {
                  if (!streams[PID]->iMpeg_Stream_Id)
                  {
                    switch (PID)
                    {
                      case PROGRAM_ASSOCIATION_TABLE:
                        printf("Found PID 0x%04X, Program Association Table Stream\n", PID);
                        break;
                      case CONDITIONAL_ACCESS_TABLE:
                        printf("Found PID 0x%04X, Conditional Access Table Stream\n", PID);
                        break;
                      case NULL_PACKET:
                        printf("Found PID 0x%04X, Null Packet Stream\n", PID);
                        break;
                      default:
                        printf("Found PID 0x%04X, Other Stream\n", PID);
                        break;
                    } // END-SWITCH PID
                  }
                  else
                    printf("Found PID 0x%04X, stream id 0x%02X = other stream\n", PID, streams[PID]->iMpeg_Stream_Id);
                }  // END-IF
          } // END-switch (streams[PID]

          streams[PID]->stream_found = 1;

          if ((streams[PID]->iMpeg_Stream_Id == PRIVATE_STREAM_1) && (vob_flag))
          {
            if (streams[PID]->stream_encrypted)
              printf("PID 0x%04X, Stream id 0x%02X, substream 0x%02X is encrypted\n", PID, streams[PID]->iMpeg_Stream_Id, streams[PID]->iMpeg_Substream_Id);
          }
          else
          {
            if (streams[PID]->stream_encrypted)
              printf("PID 0x%04X, Stream id 0x%02X is encrypted\n", PID, streams[PID]->iMpeg_Stream_Id);
          }

        }// END-if ((stream_to_get
      }
    }
	}
  } while (!end_bs());

  printf("\nSummary:\n");
  printf("\nMPEG Transport Packets = %d\n", transport_packets);
  for (i = 0; i < 8192; i++)
  {
    if (streams[i] != NULL)
    {
      if (streams[i]->stream_packets)
      {
        switch (streams[i]->iMpeg_Stream_Id)
        {
          case PROGRAM_STREAM_MAP:
            printf("PID 0x%04X, Program Stream Map packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case PRIVATE_STREAM_1:
            printf("PID 0x%04X, Private Stream 1 packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
            if (vob_flag)
            {
              j = streams[i]->iMpeg_Substream_Id;
              if ((j >= SUBSTREAM_AC3_0) && (j <= SUBSTREAM_AC3_8))
                 printf("    AC3 Audio stream %u packets = %u, total bytes = %u\n", j - SUBSTREAM_AC3_0, streams[i]->stream_packets, streams[i]->ac3_bytes);
              else
              if ((j >= SUBSTREAM_DTS_0) && (j <= SUBSTREAM_DTS_8))
                 printf("    DTS Audio stream %u packets = %u, total bytes = %u\n", j - SUBSTREAM_DTS_0, streams[i]->stream_packets, streams[i]->dts_bytes);
              else
              if ((j >= SUBSTREAM_PCM_0) && (j <= SUBSTREAM_PCM_F))
                 printf("    PCM Audio stream %u packets = %u, total bytes = %u\n", j - SUBSTREAM_PCM_0, streams[i]->stream_packets, streams[i]->pcm_bytes);
              else
              if ((j >= SUBSTREAM_SUBPIC_0) && (j <= SUBSTREAM_SUBPIC_1F))
                 printf("    Subpicture stream %u packets = %u, total bytes = %u\n", j - SUBSTREAM_SUBPIC_0, streams[i]->stream_packets, streams[i]->subpic_bytes);
              else
                 printf("    Substream 0x%02X packets = %u, total bytes = %u\n", j, streams[i]->stream_packets, streams[i]->stream_bytes);
            }
            break;
          case PRIVATE_STREAM_2:
            printf("PID 0x%04X, Private Stream 2 packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case ECM_STREAM:
            printf("PID 0x%04X, ECM Stream packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case EMM_STREAM:
            printf("PID 0x%04X, EMM Stream packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case PROGRAM_STREAM_DIRECTORY:
            printf("PID 0x%04X, Program Stream Directory packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case DSMCC_STREAM:
            printf("PID 0x%04X, DSMCC Stream packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case ITUTRECH222TYPEE_STREAM:
            printf("PID 0x%04X, ITU-T Rec. H.222.1 type E packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          case PADDING_STREAM:
            printf("PID 0x%04X, Padding Stream packets = %u, total bytes = %u\n", PID, streams[i]->stream_packets, streams[i]->stream_bytes);
            break;
          default:
            j = streams[i]->iMpeg_Stream_Id;
            if ((j >= 0xE0) && (j <= 0xEF))
              printf("PID 0x%04X, Video stream %d packets = %u, total bytes = %u\n", i, j - 0xE0, streams[i]->stream_packets, streams[i]->stream_bytes);
            else
              if ((j >= 0xC0) && (j <= 0xDF))
                printf("PID 0x%04X, MPEG Audio stream %d packets = %u, total bytes = %u\n", i, j - 0xC0, streams[i]->stream_packets, streams[i]->stream_bytes);
              else
                if (!j)
                {
                  switch (i)
                  {
                    case PROGRAM_ASSOCIATION_TABLE:
                      printf("PID 0x%04X, Program Association Table packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
                      break;
                    case CONDITIONAL_ACCESS_TABLE:
                      printf("PID 0x%04X, Conditional Access Table packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
                      break;
                    case NULL_PACKET:
                      printf("PID 0x%04X, Null packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
                      break;
                    default:
                      printf("PID 0x%04X, Other packets = %u, total bytes = %u\n", i, streams[i]->stream_packets, streams[i]->stream_bytes);
                      break;
                  }
                }
                else
                  printf("PID %04X, Other stream 0x%02X packets = %u, total bytes = %u\n", i, j, streams[i]->stream_packets, streams[i]->stream_bytes);
        }
      }
      free(streams[i]);
    }
  }

  finish_getbits();
  Out_File_CLOSE();
}
*/
